<template>
  <div>
    <!--    <transition
          :name="animation"
          mode="out-in">
          &lt;!&ndash;    <components
                :is="showingComponent"
                ref="comp"
                @close="showComponent('')"></components>&ndash;&gt;
          <SupportChat
            ref="supportChat"
            @close="showComponent('')"
            v-show="showingComponent === 'SupportChat'"></SupportChat>
        </transition>-->
    <transition
      :name="animation"
      mode="out-in">
      <HowToPlay
        ref="howToPlay"
        @close="showComponent('')"
        v-show="showingComponent === 'HowToPlay'"></HowToPlay>
    </transition>
    <transition
      :name="animation"
      mode="out-in">
      <AffProgram
        @close="showComponent('')"
        ref="affChat"
        v-show="showingComponent === 'AffProgram'"></AffProgram>
    </transition>
    <transition
      :name="animation"
      mode="out-in">
      <Terms
        @close="showComponent('')"
        ref="terms"
        v-show="showingComponent === 'Terms'"></Terms>
    </transition>
  </div>
</template>

<script>
  import ChatWood from '~/plugins/chatwood';

  export default {
    name: "TheFooterModals",
    data() {
      return {
        animation: 'slideTo-left',
        showingComponent: '',
      }
    },
    components: {
      'HowToPlay': () => import('~/components/howToPlay'),
      'AffProgram': () => import('~/components/affProgram'),
      'Terms': () => import('~/components/terms'),
    },
    computed: {
      component() {
        return this.$store.state.common.showingModal;
      },
      isDemo() {
        return this.$store.state.common.demo;
      },
      balance() {
        return this.$store.state.wallet.balance;
      },
      accountName() {
        return this.$store.state.wallet.accountName;
      }
    },
    methods: {
      showChat() {
        let accountName = this.accountName;
        let network = this.isDemo ? 'testnet' : 'mainnet';
        if (accountName === 'No account') {
          accountName = '';
        }
        accountName && window.$chatwoot.setUser(accountName, {
          name: accountName,
        });
        window.$chatwoot.setLocale(this.$i18n.locale);
        window.$chatwoot.setCustomAttributes({
          balance: this.balance.toFixed(4) + ' EOS',
          network: network,
          accountname: accountName
        });
        window.$chatwoot.toggle();
      },
      showComponent(componentName = 'HowToPlay') {
        [/*this.$refs['supportChat'],*/ this.$refs['affChat'], this.$refs['howToPlay'], this.$refs['terms']].forEach(item => {
          item.enableScroll && item.enableScroll();
        });
        componentName ? this.animation = 'slideTo-left' : this.animation = 'slideTo-right';
        this.$nextTick(_ => {
          if (componentName === 'SupportChat') {
            //this.$refs['supportChat'].enableChat();
          }
          if (componentName === 'AffProgram') this.$refs['affChat'].disableScroll();
          if (componentName === 'HowToPlay') this.$refs['howToPlay'].disableScroll();
          if (componentName === 'Terms') this.$refs['terms'].disableScroll();
          this.showingComponent = componentName;
          if (!componentName) {
            this.$store.commit('common/SET_SHOWING_MODAL', '');
          }
        });
      }
    },
    watch: {
      'component': function () {
        this.showComponent(this.component);
      }
    },
    mounted() {
      this.$root.$refs['footerModals'] = this;
      ChatWood.init(window.document, 'script');
      window.addEventListener('chatwoot:ready', () => {
        window.$chatwoot.setLabel(this.isDemo ? 'testnet' : 'mainnet');
      });
    }
  }
</script>
